--- old/usr/src/tools/smatch/src/smatch_capped.c	Tue May 19 02:50:30 2020
+++ new/usr/src/tools/smatch/src/smatch_capped.c	Tue May 19 02:50:31 2020
@@ -94,13 +94,15 @@
 
 	if (expr->type == EXPR_BINOP) {
 		struct range_list *left_rl, *right_rl;
+		sval_t sval;
 
-		if (expr->op == '&')
+		if (expr->op == '&' && !get_value(expr->right, &sval))
 			return 1;
 		if (expr->op == SPECIAL_RIGHTSHIFT)
+			return 0;
+		if (expr->op == '%' &&
+		    !get_value(expr->right, &sval) && is_capped(expr->right))
 			return 1;
-		if (expr->op == '%' && is_capped(expr->right))
-			return 1;
 		if (!is_capped(expr->left))
 			return 0;
 		if (expr->op == '/')
